/**
binary-tools-1.11 is licensed for use as follows:

"""
Copyright (c) 2023 Rafael da Silva Rocha

This work is licensed under the Creative Commons
Attribution-NonCommercial-NoDerivatives 4.0 International
(CC-BY-NC-ND 4.0). To view a copy of this license, visit
https://creativecommons.org/licenses/by-nc-nd/4.0/ or send a letter
to Creative Commons, PO Box 1866, Mountain View, CA 94042, USA.

Under the terms of this license, you are free to:
- Share: copy and distribute the work in its original form.

If you distribute this work, you must:
- Attribute: give credit to the author/owner of the work.

You may not:
- Use this work for commercial purposes.
- Create derivative works based on the work.
- Remove or alter any copyright or attribution notices on the work.

This license is granted on a worldwide, non-exclusive, and royalty-free
basis and applies to any and all versions of the work.

By using or distributing this work, you agree to be bound by the terms of
this license. If you do not agree to the terms of this license, do not use
or distribute this work.
"""

This license notice applies to parts of binary-tools-1.11
defined in the source file /lib/float-parser.js:

"""
Copyright (c) 2017-2023 Rafael da Silva Rocha.
Copyright (c) 2013 DeNA Co., Ltd.
Copyright (c) 2010, Linden Research, Inc

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"""
 */;var btools=(function(exports){var exports=exports||{};var n;function q(a,b,c,d,e){d=void 0===d?a.length:d;e=void 0===e?0:e;for(c=void 0===c?0:c;c<d;c+=b+e){var g=a,h=b,f=c;h--;for(var k=0;k<h;k++){var l=g[f+k];g[f+k]=g[f+h];g[f+h]=l;h--}}}function r(){}r.prototype.pack=function(a,b,c){for(var d=b.length,e=0;e<d;e++)a[c]=b[e]?1:0,c++;return c};r.prototype.unpack=function(a,b,c,d,e){for(;b<c;b++,e++)d[e]=!!a[b];return e};function t(a){a&&(this.o=this.D)}
t.prototype.pack=function(a,b,c){for(var d=b.length,e=d%2,g=b.length,h=0;h<g;h++)if(!e||1<d){var f=b[h+1];a[c]=this.o(b[h],c)<<4|this.o(f,c);c++;h++;d-=2}else a[c]=this.o(b[h],c)<<4,c++,d--;return c};t.prototype.unpack=function(a,b,c,d,e,g){for(;b<c&&0<g;b++,e+=2)d[e]=a[b]>>4&15,g--,0<g?(d[e+1]=a[b]&15,g--):e--;return e};t.prototype.o=function(a,b){if(15<a||0>a)throw new RangeError("index "+b+" ("+a+")");return a};t.prototype.D=function(a){return 15<a?15:0>a?0:a};
function u(a,b){this.bits=a.bits;this.offset=a.offset;this.max=Math.pow(2,this.bits)-1;this.min=0;if(void 0===b?0:b)this.$=this.ja;this.o=this.ea}n=u.prototype;n.pack=function(a,b,c,d,e){this.o=e?this.ka:this.ea;for(var g=b.length,h=0;h<g;h++){var f=b[h];if(!isFinite(f)||Math.floor(f)!==f)throw new TypeError("index "+d+" ("+f+")");f=this.$(f,d);c=this.o(a,f,c,e);d++}return c};n.ea=function(a,b,c){for(var d=0,e=this.offset;d<e;d++)a[c]=Math.floor(b/Math.pow(2,8*d))&255,c++;return c};
n.ka=function(a,b,c,d){var e=0;for(d=this.offset+d;e<d;e++)a[c]=e>=this.offset?0:Math.floor(b/Math.pow(2,8*e))&255,c++;return c};n.unpack=function(a,b,c,d,e,g){for(g=this.offset+g;b<c;b+=g,e++){for(var h=0,f=0;f<this.offset;f++)h+=a[b+f]*Math.pow(256,f);d[e]=this.$(h,b)}return e};n.$=function(a,b){if(a>this.max||a<this.min)throw new RangeError("index "+b+" ("+a+")");return a};n.ja=function(a){return a>this.max?this.max:a<this.min?this.min:a};
function v(a,b){this.bits=a.bits;this.offset=a.offset;for(var c=BigInt(2),d=BigInt(1),e=BigInt(0);e<BigInt(this.bits);e++)d*=c;this.o=d-BigInt(1);this.D=BigInt(0);if(void 0===b?0:b)this.aa=this.la;this.F=this.fa}n=v.prototype;n.pack=function(a,b,c,d,e){this.F=e?this.ma:this.fa;for(var g=b.length,h=0;h<g;h++){var f=b[h];if("bigint"!=typeof f)throw new TypeError("index "+d+" ("+f+")");f=this.aa(f,d);c=this.F(a,f,c,e);d++}return c};
n.fa=function(a,b,c){for(var d=0,e=this.offset;d<e;d++)a[c]=Number(b&BigInt(255)),b>>=BigInt(8),c++;return c};n.ma=function(a,b,c,d){var e=0;for(d=this.offset+d;e<d;e++)a[c]=e>=this.offset?0:Number(b&BigInt(255)),b>>=BigInt(8),c++;return c};n.unpack=function(a,b,c,d,e,g){for(g=this.offset+g;b<c;b+=g,e++){for(var h=BigInt(0),f=b+this.offset-1;f>=b;f--)h=h<<BigInt(8)|BigInt(a[f]);d[e]=this.aa(h,b)}return e};n.aa=function(a,b){if(a>this.o||a<this.D)throw new RangeError("index "+b+" ("+a+")");return a};
n.la=function(a){return a>this.o?this.o:a<this.D?this.D:a};function w(a,b){this.bits=a.bits;this.offset=a.offset;this.max=Math.floor((Math.pow(2,this.bits)-1)/2);this.min=-this.max-1;if(void 0===b?0:b)this.ba=this.na;this.o=this.ga}n=w.prototype;n.pack=function(a,b,c,d,e){this.o=e?this.oa:this.ga;for(var g=b.length,h=0;h<g;h++){var f=b[h];if(!isFinite(f)||Math.floor(f)!==f)throw new TypeError("index "+d+" ("+f+")");f=this.ba(f,d);f=0>f?f+2*this.max+2:f;c=this.o(a,f,c,e);d++}return c};
n.ga=function(a,b,c){for(var d=0,e=this.offset;d<e;d++)a[c]=Math.floor(b/Math.pow(2,8*d))&255,c++;return c};n.oa=function(a,b,c,d){var e=0;for(d=this.offset+d;e<d;e++)a[c]=e>=this.offset?0:Math.floor(b/Math.pow(2,8*e))&255,c++;return c};n.unpack=function(a,b,c,d,e,g){for(g=this.offset+g;b<c;b+=g,e++){for(var h=0,f=0;f<this.offset;f++)h+=a[b+f]*Math.pow(256,f);h>this.max&&(h-=2*this.max+2);d[e]=this.ba(h,b)}return e};
n.ba=function(a,b){if(a>this.max||a<this.min)throw new RangeError("index "+b+" ("+a+")");return a};n.na=function(a){return a>this.max?this.max:a<this.min?this.min:a};function x(a,b){this.bits=a.bits;this.offset=a.offset;for(var c=BigInt(2),d=BigInt(1),e=BigInt(0);e<BigInt(this.bits);e++)d*=c;this.o=d-BigInt(1);c=this.o/BigInt(2);this.o=c-c%BigInt(1);this.D=-this.o-BigInt(1);if(void 0===b?0:b)this.ca=this.pa;this.F=this.ha}n=x.prototype;
n.pack=function(a,b,c,d,e){this.F=e?this.qa:this.ha;for(var g=b.length,h=0;h<g;h++){var f=b[h];if("bigint"!=typeof f)throw new TypeError("index "+d+" ("+f+")");f=this.ca(f,d);c=this.F(a,f,c,e);d++}return c};n.ha=function(a,b,c){for(var d=0,e=this.offset;d<e;d++)a[c]=Number(b&BigInt(255)),b>>=BigInt(8),c++;return c};n.qa=function(a,b,c,d){var e=0;for(d=this.offset+d;e<d;e++)a[c]=e>=this.offset?0:Number(b&BigInt(255)),b>>=BigInt(8),c++;return c};
n.unpack=function(a,b,c,d,e,g){for(g=this.offset+g;b<c;b+=g,e++){for(var h=BigInt(0),f=b+this.offset-1;f>=b;f--)h=h<<BigInt(8)|BigInt(a[f]);h>this.o&&(h-=this.o*BigInt(2)+BigInt(2));d[e]=this.ca(h,b)}return e};n.ca=function(a,b){if(a>this.o||a<this.D)throw new RangeError("index "+b+" ("+a+")");return a};n.pa=function(a){return a>this.o?this.o:a<this.D?this.D:a};
function y(a){this.bits=a.bits;this.offset=a.offset;this.o=8;this.D=23;16!=this.bits||a.b?64==this.bits&&(this.o=11,this.D=52):(this.o=5,this.D=11);this.F=(1<<this.o-1)-1;this.X=Math.pow(2,this.F+1);this.ia=Math.pow(2,-(8*this.offset-1-this.o))}
y.prototype.pack=function(a,b,c,d){for(var e=b.length,g=0;g<e;g++){a:{var h=a,f=b[g],k=c;if("number"!==typeof f)throw new TypeError("index "+d+" ("+f+")");Math.abs(f)>this.X-2*this.bits&&(f=0>f?-Infinity:Infinity);c=0>((f=+f)||1/f)?1:0;f=Math.abs(f);var l=Math.min(Math.floor(Math.log(f)/Math.LN2),1023),m=Math.round(f/Math.pow(2,l)*Math.pow(2,this.D));if(f!==f){if(23==this.D&&2==this.offset){h[k]=193;h[k+1]=255;c=k+2;break a}m=Math.pow(2,this.D-1);l=(1<<this.o)-1}else 0!==f&&(f>=Math.pow(2,1-this.F)?
(2<=m/Math.pow(2,this.D)&&(l+=1,m=1),l>this.F?(l=(1<<this.o)-1,m=0):(l+=this.F,m=Math.round(m)-Math.pow(2,this.D))):(m=Math.round(f/Math.pow(2,1-this.F-this.D)),l=0));f=k;k=l;l=[];l.push(c);for(c=this.o;0<c;--c)l[c]=k%2?1:0,k=Math.floor(k/2);c=l.length;for(k=this.D;0<k;--k)l[c+k]=m%2?1:0,m=Math.floor(m/2);c=l.join("");m=this.offset+f-1;for(l=f;m>=f;)h[m]=parseInt(c.substring(0,8),2),c=c.substring(8),m--,l++;c=l}d++}return c};
y.prototype.unpack=function(a,b,c,d,e,g){for(g=this.offset+g;b<c;b+=g,e++){var h=(1<<this.o)-1;for(var f="",k=this.offset-1;0<=k;k--){var l=a[k+b].toString(2);f+="00000000".substring(l.length)+l}k="1"==f.charAt(0)?-1:1;f=f.substring(1);l=parseInt(f.substring(0,this.o),2);f=f.substring(this.o);l==h?h=0!==parseInt(f,2)?NaN:Infinity*k:(0===l?(l+=1,h=parseInt(f,2)):h=parseInt("1"+f,2),h=k*h*this.ia*Math.pow(2,l-this.F));d[e]=h}return e};function z(a){this.bits=a.bits;this.max=Math.pow(2,a.bits)-1}
z.prototype.pack=function(a,b,c,d){for(var e=b.length,g=0;g<e;g++){var h=b[g];if(1<h.length||"string"!==typeof h)throw new TypeError("index "+d+" ("+h+")");a[c]=A(this,h.charCodeAt(0),d);c++;d++}return c};z.prototype.unpack=function(a,b,c,d,e){for(;b<c;b++,e++)d[e]=String.fromCharCode(A(this,a[b],b));return e};function A(a,b,c){if(b>a.max||0>b)throw new TypeError("index "+c+" ("+String.fromCharCode(b)+")");return b}function B(a){this.bits=a.bits;this.max=Math.pow(2,a.bits)-1}
B.prototype.pack=function(a,b,c,d,e){var g=0;for(d=c+d;c<d;c++,g++)a[c]=g<b.length?C(this,b.charCodeAt(g),e):0;return c};B.prototype.unpack=function(a,b,c,d,e){for(d[e]="";b<c;b++)d[e]+=String.fromCharCode(C(this,a[b],b));return e+1};function C(a,b,c){if(b>a.max||0>b)throw new TypeError("index "+c+" ("+String.fromCharCode(b)+")");return b}function D(){}
D.prototype.pack=function(a,b,c,d){var e=0,g=b.length;for(d=c+d;e<g&&c<d;){var h=E(b.substring(e,e+2));if(128>h)a[c]=h,c++;else{var f=0,k=0;2047>=h?(f=1,k=192):65535>=h?(f=2,k=224):1114111>=h&&(f=3,k=240,e++);if(0==f)throw Error("Invalid UTF-8 character");if(c+f<d)for(a[c]=(h>>6*f)+k,c++;0<f;)a[c]=128|h>>6*(f-1)&63,c++,f--;else{for(;c<d;c++)a[c]=0;return c}}e++}for(;c<d;)a[c]=0,c++;return c};
D.prototype.unpack=function(a,b,c,d,e){for(var g="";b<c;){var h=128,f=191,k=!1,l=a[b++];if(0<=l&&127>=l)g+=String.fromCharCode(l);else{var m=0;194<=l&&223>=l?m=1:224<=l&&239>=l?(m=2,224===a[b]&&(h=160),237===a[b]&&(f=159)):240<=l&&244>=l?(m=3,240===a[b]&&(h=144),244===a[b]&&(f=143)):k=!0;l&=(1<<8-m-1)-1;for(var p=0;p<m;p++){if(b<c){if(a[b]<h||a[b]>f)k=!0;l=l<<6|a[b]&63}else k=!0;b++}k?g+=String.fromCharCode(65533):65535>=l?g+=String.fromCharCode(l):(l-=65536,g+=String.fromCharCode((l>>10&1023)+55296,
(l&1023)+56320))}}d[e]=g;return e+1};function F(a){for(var b=0,c=0,d=a.length;c<d;c++){var e=E(a.substring(c,c+2));128>e||(2047>=e?b++:65535>=e?b+=2:1114111>=e&&(c++,b+=3));b++}return b}function E(a){var b=a.charCodeAt(0);if(55296<=b&&56319>=b)b=1024*(b-55296)+(a.charCodeAt(1)-56320)+65536;else if(56320<=b&&57343>=b)throw Error("Invalid UTF-8 character");return b}function G(a){this.X=a.P;this.o=H;this.D=I;this.F=J;if("<"==this.X||"="==this.X)this.o=I,this.D=H,this.F=K}
G.prototype.pack=function(a,b,c,d){L(b);if(d%2)throw Error("Bad buffer length");for(var e=b.length,g=0,h=0;h<e&&g<d;h++){var f=b.charCodeAt(h);if(55296>f||57343<f)a[c]=this.o(f),c++,a[c]=this.D(f),c++,g+=2;else if(g+3>d)a[c]=0,c++,a[c]=0,c++,g+=2;else{var k=b.charCodeAt(h+1);a[c]=this.o(f);c++;a[c]=this.D(f);c++;a[c]=this.o(k);c++;a[c]=this.D(k);c++;g+=4;h++}}if(g<d)for(;g<d;g++)a[c]=0,c++;return c};
G.prototype.unpack=function(a,b,c,d,e){if((c-b)%2)throw Error("Bad buffer length");if(">"==this.X){if(255==a[b]&&254==a[b+1])throw Error("Expected UTF16 to be big-endian, but BOM indicates little-endian");}else if("<"==this.X){if(254==a[b]&&255==a[b+1])throw Error("Expected UTF16 to be little-endian, but BOM indicates big-endian");}else 254==a[b]&&255==a[b+1]?(this.o=H,this.D=I,this.F=J):255==a[b]&&254==a[b+1]&&(this.o=I,this.D=H,this.F=K);for(var g="";b<c;b+=2){var h=this.F(a,b);if(0<=h&&65535>=
h&&!(55296<=h&&57343>=h))g+=String.fromCharCode(h);else if(55296<=h&&56319>=h)if(c-1<b+2||c-1<b+3)g+="\ufffd";else{var f=this.F(a,b+2);56320<=f&&57343>=h?(g+=String.fromCharCode(h),g+=String.fromCharCode(f),b+=2):g+="\ufffd"}else g+="\ufffd"}d[e]=g;return e+1};
function L(a,b){var c=0;(void 0===b?0:b)&&"\ufeff"!==a.charAt(0)&&(c=2);for(var d=0;d<a.length;d++){var e=a.charCodeAt(d);if(56320<=e&&57343>=e)throw Error("Invalid UTF-16 character");c+=2;if(55296<=e&&56319>=e)if(56320<=a.charCodeAt(d+1)&&57343>=e)c+=2,d++;else throw Error("Invalid UTF-16 character");}return c}function H(a){return a>>8&255}function I(a){return a&255}function J(a,b){return a[b]<<8|a[b+1]}function K(a,b){return a[b]|a[b+1]<<8}
function M(a){this.o=a.P;this.D=N;this.F=O;if("<"==this.o||"="==this.o)this.D=P,this.F=Q}M.prototype.pack=function(a,b,c,d){R(b);if(d%4)throw Error("Bad buffer length");for(var e=b.length,g=0,h=0;h<e&&g<d;h++){var f=b.charCodeAt(h);var k=b.substring(h,h+2);var l=k.charCodeAt(0);55296<=l&&56319>=l&&(l=1024*(l-55296)+(k.charCodeAt(1)-56320)+65536);k=l;55296<=f&&57343>=f&&h++;c=this.D(a,c,k);g+=4}if(g<d)for(;g<d;g++)a[c]=0,c++;return c};
M.prototype.unpack=function(a,b,c,d,e){if((c-b)%4)throw Error("Bad buffer length");if("<"==this.o){if(S(a,b))throw Error("Expected UTF32 to be little-endian, but BOM indicates big-endian");}else if(">"==this.o){if(aa(a,b))throw Error("Expected UTF32 to be big-endian, but BOM indicates little-endian");}else S(a,b)?(this.D=N,this.F=O):aa(a,b)&&(this.D=P,this.F=Q);for(var g="";b<c;b+=4){var h=this.F(a,b);h=0>h?h+4294967296:h;1114111<h?h="\ufffd":65535>=h?h=String.fromCharCode(h):(h-=65536,h=String.fromCharCode((h>>
10)+55296,h%1024+56320));g+=h}d[e]=g;return e+1};function R(a,b){for(var c=(void 0===b?0:b)&&"\ufeff"!==a.charAt(0)?4:0,d=0,e=0;e<a.length;e++){var g=a.charCodeAt(e);if(55296<=g&&57343>=g)if(55296<=g&&56319>=g)if(g=a.charCodeAt(e+1),56320<=g&&57343>=g)d+=4,e++;else throw Error("Invalid UTF-32 character");else throw Error("Invalid UTF-32 character");else d+=4}return d+c}function S(a,b){return 0==a[b]&&0==a[b+1]&&254==a[b+2]&&255==a[b+3]}
function aa(a,b){return 255==a[b]&&254==a[b+1]&&0==a[b+2]&&0==a[b+3]}function N(a,b,c){a[b]=c>>24&255;a[b+1]=c>>16&255;a[b+2]=c>>8&255;a[b+3]=c&255;return b+4}function P(a,b,c){a[b]=c&255;a[b+1]=c>>8&255;a[b+2]=c>>16&255;a[b+3]=c>>24&255;return b+4}function O(a,b){return a[b]<<24|a[b+1]<<16|a[b+2]<<8|a[b+3]}function Q(a,b){return a[b+3]<<24|a[b+2]<<16|a[b+1]<<8|a[b]}
var T={x:{bits:0,signed:!1,fp:!1,c:!1,b:!1,v:!1,u:!1},c:{bits:7,signed:!1,fp:!1,c:!0,b:!1,v:!1,u:!1},C:{bits:8,signed:!1,fp:!1,c:!0,b:!1,v:!1,u:!1},s:{bits:7,signed:!1,fp:!1,c:!0,b:!1,v:!0,u:!1},S:{bits:8,signed:!1,fp:!1,c:!0,b:!1,v:!0,u:!1},u:{bits:8,signed:!1,fp:!1,c:!0,b:!1,v:!0,u:!0},U:{bits:16,signed:!1,fp:!1,c:!0,b:!1,v:!0,u:!0},V:{bits:32,signed:!1,fp:!1,c:!0,b:!1,v:!0,u:!0},N:{bits:4,signed:!1,fp:!1,c:!1,b:!0,v:!1,u:!1},b:{bits:8,signed:!0,fp:!1,c:!1,b:!1,v:!1,u:!1},B:{bits:8,signed:!1,fp:!1,
c:!1,b:!1,v:!1,u:!1},"?":{bits:1,signed:!1,fp:!1,c:!1,b:!1,v:!1,u:!1},h:{bits:16,signed:!0,fp:!1,c:!1,b:!1,v:!1,u:!1},H:{bits:16,signed:!1,fp:!1,c:!1,b:!1,v:!1,u:!1},e:{bits:16,signed:!0,fp:!0,c:!1,b:!1,v:!1,u:!1},g:{bits:16,signed:!0,fp:!0,c:!1,b:!0,v:!1,u:!1},t:{bits:24,signed:!0,fp:!1,c:!1,b:!1,v:!1,u:!1},T:{bits:24,signed:!1,fp:!1,c:!1,b:!1,v:!1,u:!1},i:{bits:32,signed:!0,fp:!1,c:!1,b:!1,v:!1,u:!1},I:{bits:32,signed:!1,fp:!1,c:!1,b:!1,v:!1,u:!1},l:{bits:32,signed:!0,fp:!1,c:!1,b:!1,v:!1,u:!1},
L:{bits:32,signed:!1,fp:!1,c:!1,b:!1,v:!1,u:!1},f:{bits:32,signed:!0,fp:!0,c:!1,b:!1,v:!1,u:!1},j:{bits:40,signed:!0,fp:!1,c:!1,b:!1,v:!1,u:!1},J:{bits:40,signed:!1,fp:!1,c:!1,b:!1,v:!1,u:!1},k:{bits:48,signed:!0,fp:!1,c:!1,b:!1,v:!1,u:!1},K:{bits:48,signed:!1,fp:!1,c:!1,b:!1,v:!1,u:!1},d:{bits:64,signed:!0,fp:!0,c:!1,b:!1,v:!1,u:!1},q:{bits:64,signed:!0,fp:!1,c:!1,b:!1,v:!1,u:!1},Q:{bits:64,signed:!1,fp:!1,c:!1,b:!1,v:!1,u:!1},A:{bits:128,signed:!1,fp:!1,c:!1,b:!1,v:!1,u:!1},Y:{bits:256,signed:!1,
fp:!1,c:!1,b:!1,v:!1,u:!1},O:{bits:512,signed:!1,fp:!1,c:!1,b:!1,v:!1,u:!1},M:{bits:1024,signed:!1,fp:!1,c:!1,b:!1,v:!1,u:!1}};function U(a){if(!a||2>a)throw Error("Unsupported type");}function ba(a,b,c,d,e,g){c.constructor!=Array&&b.length&&V(a.size,c,d);e=W(a.m,e);var h=d;d=e.pack(c,b,d,g,a.W);">"!=a.m.P&&"!"!=a.m.P||q(c,a.m.offset,h,d,a.W);return d}
function ca(a,b,c,d,e,g){if("string"!==typeof b)throw new TypeError("Item at input index "+g+" should be a string");var h=a.m;(">"==h.P||"<"==h.P)&&"\ufeff"!=b.charAt(0)&&8<h.bits&&h.u&&(b="\ufeff"+b);h=b;var f;e?f=a.G:f=a.m.u?8==a.m.bits?F(h):16==a.m.bits?L(h):R(h):h.length;e=f;c.constructor!=Array&&b.length&&V(e,c,d);return d=W(a.m).pack(c,b,d,e,g)}
function da(a,b,c,d,e,g,h,f){f&&V(a.size,b,d);var k=Math.ceil(a.m.bits/8),l=(e-d)%k;if(f&&(l||b.length<k))throw Error("Bad buffer length");e-=l;if(b.length<e)return e;b=b.slice();f=W(a.m);">"!=a.m.P&&"!"!=a.m.P||q(b,a.m.offset,d,e,a.W);return g=4==a.m.bits&&a.m.b?f.unpack(b,d,e,c,g,h):f.unpack(b,d,e,c,g,a.W)}function ea(a,b,c,d,e,g){if(b.length<e)throw Error("Bad buffer length");return g=W(a.m).unpack(b,d,e,c,g)}
function W(a,b){b=void 0===b?!1:b;if(0==a.bits||1==a.bits)return new r;if(8==a.bits&&a.u)return new D;if(16==a.bits&&a.u)return new G(a);if(32==a.bits&&a.u)return new M(a);if(a.c&&a.v)return new B(a);if(a.c)return new z(a);if(a.fp){var c=a.bits;if(!c||16!==c&&32!==c&&64!==c)throw Error("Unsupported type");return new y(a)}if(53<a.bits&&a.signed)return U(a.bits),new x(a,b);if(53<a.bits)return U(a.bits),new v(a,b);if(4==a.bits&&a.b)return U(a.bits),new t(b);if(a.signed)return U(a.bits),new w(a,b);U(a.bits);
return new u(a,b)}function V(a,b,c){if(b.length-c<a)throw Error("Bad buffer length");}function X(a,b,c){a.push({m:b,G:c})}
function Y(a,b,c,d){b=void 0===b?!0:b;c=void 0===c?!1:c;var e=a;if("string"!=typeof e)throw Error("Unsupported type");e=Z(e);if(0==e.length)throw Error("Unsupported type");for(var g=0;g<e.length;g++){var h=e.charAt(g);if(!(h in T)&&isNaN(parseInt(h,10)))throw Error("Unsupported type");}d&&(a=a.replace(/[0-9]/g,""),e={R:"~",bits:8},a=fa(a,e),a=e.bits+e.R+ha(a)+d.length.toString()+Z(a));d={R:"~",bits:8,da:!0};a=fa(a,d);"@"==d.R&&64<=d.bits?(T.l.bits=64,T.L.bits=64):(T.l.bits=32,T.L.bits=32);a=ha(a)+
Z(a);e=c;var f="0";c={ta:a,Z:0,size:0,endianness:a.charAt(0),ra:d.bits,R:d.R,types:[]};g=1;for(h=a.length;g<h;g++){var k=a.charAt(g);if(isNaN(parseInt(k,10))){k=ia(k,a);f=parseInt(f,10);f=0<f?f:1;var l=c,m=b,p=0;k.v?l.Z+=1:0!==k.bits&&(l.Z+=f);if(0!==k.bits||m)p=4==k.bits&&k.b?f/2:k.u?f:Math.ceil(k.offset*f);l.types.push({m:k,G:f,size:p,W:"~"==l.R?0:k.align-k.offset});l.size+=p;f="0";if(e)break}else f+=k}a=c.types;for(e=0;e<a.length-1;e++)a[e].m!=a[e+1].m||a[e].m.v||(a[e].G+=a[e+1].G,a[e].size+=a[e+
1].size,a.splice(e+1,1),e--);if("~"!==c.R){a=ia("x","=");d=d.da;e=[];g=c.types;h=c.ra/8;for(f=k=0;f<g.length;f++)if(0!=g[f].m.bits){if(g[f].m.v)l=h<g[f].m.offset?h:g[f].m.offset,k%l?(l-=k%l,X(e,a,l),k+=l,f--):(e.push(g[f]),k=h-(h-(k+g[f].G)%h));else if(g[f].m.b&&4==g[f].m.bits)e.push(g[f]),k=h-(h-(k+Math.ceil(g[f].m.offset*g[f].G))%h);else{l=g[f].G;for(m=0;m<l;m++)Math.ceil(g[f].m.align)>=h?0==k?(g[f].G=1,g[f].W=g[f].m.align-g[f].m.offset,g[f].size=Math.ceil(g[f].m.offset*g[f].G),e.push(g[f]),g[f].m.offset<
g[f].m.align&&X(e,a,g[f].m.align-g[f].m.offset%g[f].m.align)):(X(e,a,h-k%h),k=0,m--):g[f].m.align+k>h?(k=h-k%h,k<h&&X(e,a,k),k=0,m--):k%g[f].m.align?(p=g[f].m.align-k%g[f].m.align,X(e,a,p),k+=p,m--):(k+=g[f].m.offset,g[f].G=1,g[f].W=g[f].m.align-g[f].m.offset,e.push(g[f]),g[f].m.offset<g[f].m.align&&(p=g[f].m.align-k%g[f].m.align,X(e,a,p),k+=p));k>=h&&(k%=h)}f==g.length-1&&d&&(l=h-k%h,l<h&&X(e,a,l))}c.types=e;for(d=c.size=0;d<c.types.length;d++)c.types[d].m.u?(c.size+=c.types[d].G,c.types[d].size+=
c.types[d].G):0==c.types[d].m.bits&&b?(c.size+=c.types[d].G,c.types[d].size+=c.types[d].G):(c.size+=c.types[d].m.offset*c.types[d].G,c.types[d].size=c.types[d].m.offset*c.types[d].G)}c.size=Math.ceil(c.size);return c}function Z(a){return a.replace(/[<>!=@#~%&\+\-]/g,"")}
function fa(a,b){for(var c=["~","@","#"],d=0;d<c.length;d++)if(-1<a.indexOf(c[d])){var e=a.split(c[d]);a=e[1];b.R=c[d];c=""==e[0]?0:parseInt(e[0],10);b.bits=0==c?8:c;if(b.bits%8||isNaN(b.bits)||0>b.bits)throw Error("Architecture bit width must be a multiple of the bit width (8)");break}c=a.slice(-1);"%"==c?(a=a.slice(0,-1),b.da=!1):"&"==c&&(a=a.slice(0,-1),b.da=!0);return a}function ha(a){var b="=";a=a.charAt(0);if("!"==a||"<"==a||">"==a)b=a;return b}
function ia(a,b){var c=T[a];c.P=b.charAt(0);c.offset=Math.ceil((0<c.bits?c.bits:1)/8);if(8<c.offset){var d=c.offset;var e=d%8;d=0===e?d:d+(8-e)}else d=4<c.offset?8:2<c.offset?4:c.offset;c.align=d;4==c.bits&&c.b&&(c.offset=.5,c.align=1);return c}
function ja(a,b,c,d,e){d=void 0===d?0:d;e=void 0===e?!1:e;b=ka(b);a=Y(a);if(a.Z>b.length)throw Error("Number of values do not match the format");for(var g=0,h=0,f=a.types.length;g<f;g++){var k=a.types[g];k.W=0;if(0===k.m.bits)for(var l=0;l<k.G;l++)c[d]=0,d++;else k.m.v?(d=ca(k,b[h],c,d,!0,h),h++):(d=ba(k,b.slice(h,h+k.G),c,d,e,g),h+=k.G)}return d}
function la(a,b,c,d,e){d=void 0===d?0:d;e=void 0===e?!1:e;a=Y(a);for(var g=a.types.length,h=0,f=0;h<g;h++){var k=a.types[h].G,l=a.types[h];l.W=0;var m=l.m.bits&&!l.m.u?l.m.offset*k:k;m=Math.ceil(m);var p=d+m;l.m.v?f=ea(l,b,c,d,p,f):0!==l.m.bits&&(f=da(l,b,c,d,p,f,k,e));d+=m}}function ma(a,b,c,d,e){d=void 0===d?0:d;e=void 0===e?!1:e;b=ka(b);a=Y(a,!0,!0,b).types[0];if(4==a.m.bits&&a.m.b&&b.length%2)throw Error("Odd number of nibbles");return a.m.v?ca(a,b[0],c,d,!1,0):ba(a,b,c,d,e,0)}
function na(a,b,c,d,e,g){d=void 0===d?0:d;e=void 0===e?b.length:e;g=void 0===g?!1:g;a=Y(a,!0,!0).types[0];return a.m.v?ea(a,b,c,d,e,0):da(a,b,c,d,e,0,2*(e-d+1),g)}function ka(a){null!==a&&void 0!==a&&"string"!==typeof a&&"function"!==typeof a&&"number"===typeof a.length&&0<=a.length&&a.length===Math.floor(a.length)||(a=[a]);return a}exports.bytesToHex=function(a){for(var b="",c=0;c<a.length;c++){if(0>a[c]||255<a[c])throw new RangeError;var d=a[c].toString(16);b+=1==d.length?"0"+d:d}return b};
exports.calcSize=function(a,b){return Y(a,void 0===b?!1:b).size};exports.sa=function(a,b){var c=Y(a,!0,!0,b);return c.types[0]&&b.length?Math.ceil(c.types[0].size):0};exports.endianness=q;exports.hexToBytes=function(a){if(0!==a.length%2&&0<a.length)throw Error("Invalid hex string");if(!/^[0-9a-fA-F]+$/.test(a)&&0<a.length)throw new RangeError("Invalid hex string");for(var b=[],c=0;c<a.length;c+=2)b.push(parseInt(a.substr(c,2),16));return b};
exports.pack=function(a,b,c){var d=[];ja(a,b,d,0,void 0===c?!1:c);return d};exports.packTo=ja;exports.read=function(a,b,c,d,e){d=void 0===d?b.length:d;var g=[];na(a,b,g,void 0===c?0:c,d,void 0===e?!1:e);return g};exports.readTo=na;exports.types=T;exports.unpack=function(a,b,c,d){var e=[];la(a,b,e,void 0===c?0:c,void 0===d?!1:d);return e};exports.unpackTo=la;exports.utf16BufferSize=L;exports.utf32BufferSize=R;exports.utf8BufferSize=F;
exports.write=function(a,b,c){var d=[];ma(a,b,d,0,void 0===c?!1:c);return d};exports.writeTo=ma;typeof module!=='undefined'?module.exports=exports :typeof define==='function'&&define.amd?define(['exports'],exports) :typeof global!=='undefined'?global.btools=exports:null;return exports;})();var binaryTools = btools
