/**
binary-tools-1.11 is licensed for use as follows:

"""
Copyright (c) 2023 Rafael da Silva Rocha

This work is licensed under the Creative Commons
Attribution-NonCommercial-NoDerivatives 4.0 International
(CC-BY-NC-ND 4.0). To view a copy of this license, visit
https://creativecommons.org/licenses/by-nc-nd/4.0/ or send a letter
to Creative Commons, PO Box 1866, Mountain View, CA 94042, USA.

Under the terms of this license, you are free to:
- Share: copy and distribute the work in its original form.

If you distribute this work, you must:
- Attribute: give credit to the author/owner of the work.

You may not:
- Use this work for commercial purposes.
- Create derivative works based on the work.
- Remove or alter any copyright or attribution notices on the work.

This license is granted on a worldwide, non-exclusive, and royalty-free
basis and applies to any and all versions of the work.

By using or distributing this work, you agree to be bound by the terms of
this license. If you do not agree to the terms of this license, do not use
or distribute this work.
"""

This license notice applies to parts of binary-tools-1.11
defined in the source file /lib/float-parser.js:

"""
Copyright (c) 2017-2023 Rafael da Silva Rocha.
Copyright (c) 2013 DeNA Co., Ltd.
Copyright (c) 2010, Linden Research, Inc

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"""
 */function p(a,b,c=0,d=a.length,g=0){for(let h=c;h<d;h+=b+g){c=a;var e=b,f=h;e--;for(let k=0;k<e;k++){let l=c[f+k];c[f+k]=c[f+e];c[f+e]=l;e--}}}class aa{pack(a,b,c){for(let d=b.length,g=0;g<d;g++)a[c]=b[g]?1:0,c++;return c}unpack(a,b,c,d,g){for(;b<c;b++,g++)d[g]=!!a[b];return g}}
class ba{constructor(a){a&&(this.o=this.D)}pack(a,b,c){let d=b.length,g=d%2;for(let e=b.length,f=0;f<e;f++)if(!g||1<d){let h=b[f+1];a[c]=this.o(b[f],c)<<4|this.o(h,c);c++;f++;d-=2}else a[c]=this.o(b[f],c)<<4,c++,d--;return c}unpack(a,b,c,d,g,e){for(;b<c&&0<e;b++,g+=2)d[g]=a[b]>>4&15,e--,0<e?(d[g+1]=a[b]&15,e--):g--;return g}o(a,b){if(15<a||0>a)throw new RangeError("index "+b+" ("+a+")");return a}D(a){return 15<a?15:0>a?0:a}}
class ca{constructor(a,b=!1){this.bits=a.bits;this.offset=a.offset;this.max=Math.pow(2,this.bits)-1;this.min=0;b&&(this.o=this.P);this.D=this.F}pack(a,b,c,d,g){this.D=g?this.R:this.F;for(let e=b.length,f=0;f<e;f++){let h=b[f];if(!isFinite(h)||Math.floor(h)!==h)throw new TypeError("index "+d+" ("+h+")");h=this.o(h,d);c=this.D(a,h,c,g);d++}return c}F(a,b,c){for(let d=0,g=this.offset;d<g;d++)a[c]=Math.floor(b/Math.pow(2,8*d))&255,c++;return c}R(a,b,c,d){for(let g=0,e=this.offset+d;g<e;g++)a[c]=g>=this.offset?
0:Math.floor(b/Math.pow(2,8*g))&255,c++;return c}unpack(a,b,c,d,g,e){for(e=this.offset+e;b<c;b+=e,g++){let f=0;for(let h=0;h<this.offset;h++)f+=a[b+h]*Math.pow(256,h);d[g]=this.o(f,b)}return g}o(a,b){if(a>this.max||a<this.min)throw new RangeError("index "+b+" ("+a+")");return a}P(a){return a>this.max?this.max:a<this.min?this.min:a}}
class da{constructor(a,b=!1){this.bits=a.bits;this.offset=a.offset;a=BigInt(2);let c=BigInt(1);for(let d=BigInt(0);d<BigInt(this.bits);d++)c*=a;this.o=c-BigInt(1);this.D=BigInt(0);b&&(this.F=this.aa);this.P=this.R}pack(a,b,c,d,g){this.P=g?this.ba:this.R;for(let e=b.length,f=0;f<e;f++){let h=b[f];if("bigint"!=typeof h)throw new TypeError("index "+d+" ("+h+")");h=this.F(h,d);c=this.P(a,h,c,g);d++}return c}R(a,b,c){for(let d=0,g=this.offset;d<g;d++)a[c]=Number(b&BigInt(255)),b>>=BigInt(8),c++;return c}ba(a,
b,c,d){for(let g=0,e=this.offset+d;g<e;g++)a[c]=g>=this.offset?0:Number(b&BigInt(255)),b>>=BigInt(8),c++;return c}unpack(a,b,c,d,g,e){for(e=this.offset+e;b<c;b+=e,g++){let f=BigInt(0);for(let h=b+this.offset-1;h>=b;h--)f=f<<BigInt(8)|BigInt(a[h]);d[g]=this.F(f,b)}return g}F(a,b){if(a>this.o||a<this.D)throw new RangeError("index "+b+" ("+a+")");return a}aa(a){return a>this.o?this.o:a<this.D?this.D:a}}
class ea{constructor(a,b=!1){this.bits=a.bits;this.offset=a.offset;this.max=Math.floor((Math.pow(2,this.bits)-1)/2);this.min=-this.max-1;b&&(this.o=this.P);this.D=this.F}pack(a,b,c,d,g){this.D=g?this.R:this.F;for(let e=b.length,f=0;f<e;f++){let h=b[f];if(!isFinite(h)||Math.floor(h)!==h)throw new TypeError("index "+d+" ("+h+")");h=this.o(h,d);h=0>h?h+2*this.max+2:h;c=this.D(a,h,c,g);d++}return c}F(a,b,c){for(let d=0,g=this.offset;d<g;d++)a[c]=Math.floor(b/Math.pow(2,8*d))&255,c++;return c}R(a,b,c,
d){for(let g=0,e=this.offset+d;g<e;g++)a[c]=g>=this.offset?0:Math.floor(b/Math.pow(2,8*g))&255,c++;return c}unpack(a,b,c,d,g,e){for(e=this.offset+e;b<c;b+=e,g++){var f=0;for(let h=0;h<this.offset;h++)f+=a[b+h]*Math.pow(256,h);f>this.max&&(f-=2*this.max+2);d[g]=this.o(f,b)}return g}o(a,b){if(a>this.max||a<this.min)throw new RangeError("index "+b+" ("+a+")");return a}P(a){return a>this.max?this.max:a<this.min?this.min:a}}
class fa{constructor(a,b=!1){this.bits=a.bits;this.offset=a.offset;a=BigInt(2);let c=BigInt(1);for(let d=BigInt(0);d<BigInt(this.bits);d++)c*=a;this.o=c-BigInt(1);a=this.o/BigInt(2);this.o=a-a%BigInt(1);this.D=-this.o-BigInt(1);b&&(this.F=this.aa);this.P=this.R}pack(a,b,c,d,g){this.P=g?this.ba:this.R;for(let e=b.length,f=0;f<e;f++){let h=b[f];if("bigint"!=typeof h)throw new TypeError("index "+d+" ("+h+")");h=this.F(h,d);c=this.P(a,h,c,g);d++}return c}R(a,b,c){for(let d=0,g=this.offset;d<g;d++)a[c]=
Number(b&BigInt(255)),b>>=BigInt(8),c++;return c}ba(a,b,c,d){for(let g=0,e=this.offset+d;g<e;g++)a[c]=g>=this.offset?0:Number(b&BigInt(255)),b>>=BigInt(8),c++;return c}unpack(a,b,c,d,g,e){for(e=this.offset+e;b<c;b+=e,g++){var f=BigInt(0);for(let h=b+this.offset-1;h>=b;h--)f=f<<BigInt(8)|BigInt(a[h]);f>this.o&&(f-=this.o*BigInt(2)+BigInt(2));d[g]=this.F(f,b)}return g}F(a,b){if(a>this.o||a<this.D)throw new RangeError("index "+b+" ("+a+")");return a}aa(a){return a>this.o?this.o:a<this.D?this.D:a}}
class ha{constructor(a){this.bits=a.bits;this.offset=a.offset;this.o=8;this.D=23;16!=this.bits||a.b?64==this.bits&&(this.o=11,this.D=52):(this.o=5,this.D=11);this.F=(1<<this.o-1)-1;this.P=Math.pow(2,this.F+1);this.R=Math.pow(2,-(8*this.offset-1-this.o))}pack(a,b,c,d){for(let l=b.length,m=0;m<l;m++){a:{var g=a,e=b[m],f=c;if("number"!==typeof e)throw new TypeError("index "+d+" ("+e+")");Math.abs(e)>this.P-2*this.bits&&(e=0>e?-Infinity:Infinity);c=0>((e=+e)||1/e)?1:0;e=Math.abs(e);var h=Math.min(Math.floor(Math.log(e)/
Math.LN2),1023),k=Math.round(e/Math.pow(2,h)*Math.pow(2,this.D));if(e!==e){if(23==this.D&&2==this.offset){g[f]=193;g[f+1]=255;c=f+2;break a}k=Math.pow(2,this.D-1);h=(1<<this.o)-1}else 0!==e&&(e>=Math.pow(2,1-this.F)?(2<=k/Math.pow(2,this.D)&&(h+=1,k=1),h>this.F?(h=(1<<this.o)-1,k=0):(h+=this.F,k=Math.round(k)-Math.pow(2,this.D))):(k=Math.round(e/Math.pow(2,1-this.F-this.D)),h=0));e=f;f=h;h=[];h.push(c);for(c=this.o;0<c;--c)h[c]=f%2?1:0,f=Math.floor(f/2);c=h.length;for(f=this.D;0<f;--f)h[c+f]=k%2?
1:0,k=Math.floor(k/2);c=h.join("");k=this.offset+e-1;for(h=e;k>=e;)g[k]=parseInt(c.substring(0,8),2),c=c.substring(8),k--,h++;c=h}d++}return c}unpack(a,b,c,d,g,e){for(e=this.offset+e;b<c;b+=e,g++){{var f=(1<<this.o)-1;let l="";for(var h=this.offset-1;0<=h;h--){var k=a[h+b].toString(2);l+="00000000".substring(k.length)+k}h="1"==l.charAt(0)?-1:1;l=l.substring(1);k=parseInt(l.substring(0,this.o),2);l=l.substring(this.o);k==f?f=0!==parseInt(l,2)?NaN:Infinity*h:(0===k?(k+=1,f=parseInt(l,2)):f=parseInt("1"+
l,2),f=h*f*this.R*Math.pow(2,k-this.F))}d[g]=f}return g}}function q(a,b,c){if(b>a.max||0>b)throw new TypeError("index "+c+" ("+String.fromCharCode(b)+")");return b}
class ia{constructor(a){this.bits=a.bits;this.max=Math.pow(2,a.bits)-1}pack(a,b,c,d){for(let g=b.length,e=0;e<g;e++){let f=b[e];if(1<f.length||"string"!==typeof f)throw new TypeError("index "+d+" ("+f+")");a[c]=q(this,f.charCodeAt(0),d);c++;d++}return c}unpack(a,b,c,d,g){for(;b<c;b++,g++)d[g]=String.fromCharCode(q(this,a[b],b));return g}}function r(a,b,c){if(b>a.max||0>b)throw new TypeError("index "+c+" ("+String.fromCharCode(b)+")");return b}
class ja{constructor(a){this.bits=a.bits;this.max=Math.pow(2,a.bits)-1}pack(a,b,c,d,g){let e=0;for(d=c+d;c<d;c++,e++)a[c]=e<b.length?r(this,b.charCodeAt(e),g):0;return c}unpack(a,b,c,d,g){for(d[g]="";b<c;b++)d[g]+=String.fromCharCode(r(this,a[b],b));return g+1}}
class ka{pack(a,b,c,d){let g=0,e=b.length;for(d=c+d;g<e&&c<d;){let f=t(b.substring(g,g+2));if(128>f)a[c]=f,c++;else{let h=0,k=0;2047>=f?(h=1,k=192):65535>=f?(h=2,k=224):1114111>=f&&(h=3,k=240,g++);if(0==h)throw Error("Invalid UTF-8 character");if(c+h<d)for(a[c]=(f>>6*h)+k,c++;0<h;)a[c]=128|f>>6*(h-1)&63,c++,h--;else{for(;c<d;c++)a[c]=0;return c}}g++}for(;c<d;)a[c]=0,c++;return c}unpack(a,b,c,d,g){let e="";for(;b<c;){let f=128,h=191,k=!1,l=a[b++];if(0<=l&&127>=l)e+=String.fromCharCode(l);else{let m=
0;194<=l&&223>=l?m=1:224<=l&&239>=l?(m=2,224===a[b]&&(f=160),237===a[b]&&(h=159)):240<=l&&244>=l?(m=3,240===a[b]&&(f=144),244===a[b]&&(h=143)):k=!0;l&=(1<<8-m-1)-1;for(let n=0;n<m;n++){if(b<c){if(a[b]<f||a[b]>h)k=!0;l=l<<6|a[b]&63}else k=!0;b++}k?e+=String.fromCharCode(65533):65535>=l?e+=String.fromCharCode(l):(l-=65536,e+=String.fromCharCode((l>>10&1023)+55296,(l&1023)+56320))}}d[g]=e;return g+1}}
function u(a){let b=0;for(let c=0,d=a.length;c<d;c++){let g=t(a.substring(c,c+2));128>g||(2047>=g?b++:65535>=g?b+=2:1114111>=g&&(c++,b+=3));b++}return b}function t(a){let b=a.charCodeAt(0);if(55296<=b&&56319>=b)b=1024*(b-55296)+(a.charCodeAt(1)-56320)+65536;else if(56320<=b&&57343>=b)throw Error("Invalid UTF-8 character");return b}
class la{constructor(a){this.P=a.W;this.o=v;this.D=w;this.F=x;if("<"==this.P||"="==this.P)this.o=w,this.D=v,this.F=y}pack(a,b,c,d){z(b);if(d%2)throw Error("Bad buffer length");let g=b.length,e=0;for(let f=0;f<g&&e<d;f++){let h=b.charCodeAt(f);if(55296>h||57343<h)a[c]=this.o(h),c++,a[c]=this.D(h),c++,e+=2;else if(e+3>d)a[c]=0,c++,a[c]=0,c++,e+=2;else{let k=b.charCodeAt(f+1);a[c]=this.o(h);c++;a[c]=this.D(h);c++;a[c]=this.o(k);c++;a[c]=this.D(k);c++;e+=4;f++}}if(e<d)for(;e<d;e++)a[c]=0,c++;return c}unpack(a,
b,c,d,g){if((c-b)%2)throw Error("Bad buffer length");if(">"==this.P){if(255==a[b]&&254==a[b+1])throw Error("Expected UTF16 to be big-endian, but BOM indicates little-endian");}else if("<"==this.P){if(254==a[b]&&255==a[b+1])throw Error("Expected UTF16 to be little-endian, but BOM indicates big-endian");}else 254==a[b]&&255==a[b+1]?(this.o=v,this.D=w,this.F=x):255==a[b]&&254==a[b+1]&&(this.o=w,this.D=v,this.F=y);let e="";for(;b<c;b+=2){let f=this.F(a,b);if(0<=f&&65535>=f&&!(55296<=f&&57343>=f))e+=String.fromCharCode(f);
else if(55296<=f&&56319>=f)if(c-1<b+2||c-1<b+3)e+="\ufffd";else{let h=this.F(a,b+2);56320<=h&&57343>=f?(e+=String.fromCharCode(f),e+=String.fromCharCode(h),b+=2):e+="\ufffd"}else e+="\ufffd"}d[g]=e;return g+1}}
function z(a,b=!1){let c=0;b&&"\ufeff"!==a.charAt(0)&&(c=2);for(b=0;b<a.length;b++){let d=a.charCodeAt(b);if(56320<=d&&57343>=d)throw Error("Invalid UTF-16 character");c+=2;if(55296<=d&&56319>=d)if(56320<=a.charCodeAt(b+1)&&57343>=d)c+=2,b++;else throw Error("Invalid UTF-16 character");}return c}function v(a){return a>>8&255}function w(a){return a&255}function x(a,b){return a[b]<<8|a[b+1]}function y(a,b){return a[b]|a[b+1]<<8}
class ma{constructor(a){this.o=a.W;this.D=A;this.F=B;if("<"==this.o||"="==this.o)this.D=C,this.F=D}pack(a,b,c,d){E(b);if(d%4)throw Error("Bad buffer length");let g=b.length,e=0;for(let h=0;h<g&&e<d;h++){let k=b.charCodeAt(h);var f=b.substring(h,h+2);let l=f.charCodeAt(0);55296<=l&&56319>=l&&(l=1024*(l-55296)+(f.charCodeAt(1)-56320)+65536);f=l;55296<=k&&57343>=k&&h++;c=this.D(a,c,f);e+=4}if(e<d)for(;e<d;e++)a[c]=0,c++;return c}unpack(a,b,c,d,g){if((c-b)%4)throw Error("Bad buffer length");if("<"==this.o){if(F(a,
b))throw Error("Expected UTF32 to be little-endian, but BOM indicates big-endian");}else if(">"==this.o){if(G(a,b))throw Error("Expected UTF32 to be big-endian, but BOM indicates little-endian");}else F(a,b)?(this.D=A,this.F=B):G(a,b)&&(this.D=C,this.F=D);let e="";for(;b<c;b+=4){var f=this.F(a,b);f=0>f?f+4294967296:f;1114111<f?f="\ufffd":65535>=f?f=String.fromCharCode(f):(f-=65536,f=String.fromCharCode((f>>10)+55296,f%1024+56320));e+=f}d[g]=e;return g+1}}
function E(a,b=!1){b=b&&"\ufeff"!==a.charAt(0)?4:0;let c=0;for(let g=0;g<a.length;g++){var d=a.charCodeAt(g);if(55296<=d&&57343>=d)if(55296<=d&&56319>=d)if(d=a.charCodeAt(g+1),56320<=d&&57343>=d)c+=4,g++;else throw Error("Invalid UTF-32 character");else throw Error("Invalid UTF-32 character");else c+=4}return c+b}function F(a,b){return 0==a[b]&&0==a[b+1]&&254==a[b+2]&&255==a[b+3]}function G(a,b){return 255==a[b]&&254==a[b+1]&&0==a[b+2]&&0==a[b+3]}
function A(a,b,c){a[b]=c>>24&255;a[b+1]=c>>16&255;a[b+2]=c>>8&255;a[b+3]=c&255;return b+4}function C(a,b,c){a[b]=c&255;a[b+1]=c>>8&255;a[b+2]=c>>16&255;a[b+3]=c>>24&255;return b+4}function B(a,b){return a[b]<<24|a[b+1]<<16|a[b+2]<<8|a[b+3]}function D(a,b){return a[b+3]<<24|a[b+2]<<16|a[b+1]<<8|a[b]}
let H={x:{bits:0,signed:!1,fp:!1,c:!1,b:!1,v:!1,u:!1},c:{bits:7,signed:!1,fp:!1,c:!0,b:!1,v:!1,u:!1},C:{bits:8,signed:!1,fp:!1,c:!0,b:!1,v:!1,u:!1},s:{bits:7,signed:!1,fp:!1,c:!0,b:!1,v:!0,u:!1},S:{bits:8,signed:!1,fp:!1,c:!0,b:!1,v:!0,u:!1},u:{bits:8,signed:!1,fp:!1,c:!0,b:!1,v:!0,u:!0},U:{bits:16,signed:!1,fp:!1,c:!0,b:!1,v:!0,u:!0},V:{bits:32,signed:!1,fp:!1,c:!0,b:!1,v:!0,u:!0},N:{bits:4,signed:!1,fp:!1,c:!1,b:!0,v:!1,u:!1},b:{bits:8,signed:!0,fp:!1,c:!1,b:!1,v:!1,u:!1},B:{bits:8,signed:!1,fp:!1,
c:!1,b:!1,v:!1,u:!1},"?":{bits:1,signed:!1,fp:!1,c:!1,b:!1,v:!1,u:!1},h:{bits:16,signed:!0,fp:!1,c:!1,b:!1,v:!1,u:!1},H:{bits:16,signed:!1,fp:!1,c:!1,b:!1,v:!1,u:!1},e:{bits:16,signed:!0,fp:!0,c:!1,b:!1,v:!1,u:!1},g:{bits:16,signed:!0,fp:!0,c:!1,b:!0,v:!1,u:!1},t:{bits:24,signed:!0,fp:!1,c:!1,b:!1,v:!1,u:!1},T:{bits:24,signed:!1,fp:!1,c:!1,b:!1,v:!1,u:!1},i:{bits:32,signed:!0,fp:!1,c:!1,b:!1,v:!1,u:!1},I:{bits:32,signed:!1,fp:!1,c:!1,b:!1,v:!1,u:!1},l:{bits:32,signed:!0,fp:!1,c:!1,b:!1,v:!1,u:!1},
L:{bits:32,signed:!1,fp:!1,c:!1,b:!1,v:!1,u:!1},f:{bits:32,signed:!0,fp:!0,c:!1,b:!1,v:!1,u:!1},j:{bits:40,signed:!0,fp:!1,c:!1,b:!1,v:!1,u:!1},J:{bits:40,signed:!1,fp:!1,c:!1,b:!1,v:!1,u:!1},k:{bits:48,signed:!0,fp:!1,c:!1,b:!1,v:!1,u:!1},K:{bits:48,signed:!1,fp:!1,c:!1,b:!1,v:!1,u:!1},d:{bits:64,signed:!0,fp:!0,c:!1,b:!1,v:!1,u:!1},q:{bits:64,signed:!0,fp:!1,c:!1,b:!1,v:!1,u:!1},Q:{bits:64,signed:!1,fp:!1,c:!1,b:!1,v:!1,u:!1},A:{bits:128,signed:!1,fp:!1,c:!1,b:!1,v:!1,u:!1},Y:{bits:256,signed:!1,
fp:!1,c:!1,b:!1,v:!1,u:!1},O:{bits:512,signed:!1,fp:!1,c:!1,b:!1,v:!1,u:!1},M:{bits:1024,signed:!1,fp:!1,c:!1,b:!1,v:!1,u:!1}};function I(a){if(!a||2>a)throw Error("Unsupported type");}function J(a,b,c,d,g,e){c.constructor!=Array&&b.length&&K(a.size,c,d);g=L(a.m,g);let f=d;d=g.pack(c,b,d,e,a.Z);">"!=a.m.W&&"!"!=a.m.W||p(c,a.m.offset,f,d,a.Z);return d}
function M(a,b,c,d,g,e){if("string"!==typeof b)throw new TypeError("Item at input index "+e+" should be a string");var f=a.m;(">"==f.W||"<"==f.W)&&"\ufeff"!=b.charAt(0)&&8<f.bits&&f.u&&(b="\ufeff"+b);f=b;let h;g?h=a.G:h=a.m.u?8==a.m.bits?u(f):16==a.m.bits?z(f):E(f):f.length;g=h;c.constructor!=Array&&b.length&&K(g,c,d);return d=L(a.m).pack(c,b,d,g,e)}
function N(a,b,c,d,g,e,f,h){h&&K(a.size,b,d);var k=Math.ceil(a.m.bits/8);let l=(g-d)%k;if(h&&(l||b.length<k))throw Error("Bad buffer length");g-=l;if(b.length<g)return g;b=b.slice();h=L(a.m);">"!=a.m.W&&"!"!=a.m.W||p(b,a.m.offset,d,g,a.Z);return e=4==a.m.bits&&a.m.b?h.unpack(b,d,g,c,e,f):h.unpack(b,d,g,c,e,a.Z)}function O(a,b,c,d,g,e){if(b.length<g)throw Error("Bad buffer length");return e=L(a.m).unpack(b,d,g,c,e)}
function L(a,b=!1){if(0==a.bits||1==a.bits)return new aa;if(8==a.bits&&a.u)return new ka;if(16==a.bits&&a.u)return new la(a);if(32==a.bits&&a.u)return new ma(a);if(a.c&&a.v)return new ja(a);if(a.c)return new ia(a);if(a.fp){b=a.bits;if(!b||16!==b&&32!==b&&64!==b)throw Error("Unsupported type");return new ha(a)}if(53<a.bits&&a.signed)return I(a.bits),new fa(a,b);if(53<a.bits)return I(a.bits),new da(a,b);if(4==a.bits&&a.b)return I(a.bits),new ba(b);if(a.signed)return I(a.bits),new ea(a,b);I(a.bits);
return new ca(a,b)}function K(a,b,c){if(b.length-c<a)throw Error("Bad buffer length");}function P(a,b,c){a.push({m:b,G:c})}
function Q(a,b=!0,c=!1,d){var g=a;if("string"!=typeof g)throw Error("Unsupported type");g=R(g);if(0==g.length)throw Error("Unsupported type");for(var e=0;e<g.length;e++){var f=g.charAt(e);if(!(f in H)&&isNaN(parseInt(f,10)))throw Error("Unsupported type");}d&&(g=a.replace(/[0-9]/g,""),a={X:"~",bits:8},g=S(g,a),a=a.bits+a.X+T(g)+d.length.toString()+R(g));g={X:"~",bits:8,ca:!0};a=S(a,g);"@"==g.X&&64<=g.bits?(H.l.bits=64,H.L.bits=64):(H.l.bits=32,H.L.bits=32);a=T(a)+R(a);e="0";d={ea:a,$:0,size:0,endianness:a.charAt(0),
da:g.bits,X:g.X,types:[]};for(let n=1,na=a.length;n<na;n++)if(f=a.charAt(n),isNaN(parseInt(f,10))){f=U(f,a);e=parseInt(e,10);e=0<e?e:1;var h=d,k=b,l=0;f.v?h.$+=1:0!==f.bits&&(h.$+=e);if(0!==f.bits||k)l=4==f.bits&&f.b?e/2:f.u?e:Math.ceil(f.offset*e);h.types.push({m:f,G:e,size:l,Z:"~"==h.X?0:f.align-f.offset});h.size+=l;e="0";if(c)break}else e+=f;c=d.types;for(a=0;a<c.length-1;a++)c[a].m!=c[a+1].m||c[a].m.v||(c[a].G+=c[a+1].G,c[a].size+=c[a+1].size,c.splice(a+1,1),a--);if("~"!==d.X){c=U("x","=");g=
g.ca;a=[];e=d.types;f=d.da/8;k=0;for(h=0;h<e.length;h++)if(0!=e[h].m.bits){if(e[h].m.v)l=f<e[h].m.offset?f:e[h].m.offset,k%l?(l-=k%l,P(a,c,l),k+=l,h--):(a.push(e[h]),k=f-(f-(k+e[h].G)%f));else if(e[h].m.b&&4==e[h].m.bits)a.push(e[h]),k=f-(f-(k+Math.ceil(e[h].m.offset*e[h].G))%f);else{l=e[h].G;for(let n=0;n<l;n++)if(Math.ceil(e[h].m.align)>=f)0==k?(e[h].G=1,e[h].Z=e[h].m.align-e[h].m.offset,e[h].size=Math.ceil(e[h].m.offset*e[h].G),a.push(e[h]),e[h].m.offset<e[h].m.align&&P(a,c,e[h].m.align-e[h].m.offset%
e[h].m.align)):(P(a,c,f-k%f),k=0,n--);else if(e[h].m.align+k>f)k=f-k%f,k<f&&P(a,c,k),k=0,n--;else if(k%e[h].m.align){var m=e[h].m.align-k%e[h].m.align;P(a,c,m);k+=m;n--}else k+=e[h].m.offset,e[h].G=1,e[h].Z=e[h].m.align-e[h].m.offset,a.push(e[h]),e[h].m.offset<e[h].m.align&&(m=e[h].m.align-k%e[h].m.align,P(a,c,m),k+=m);k>=f&&(k%=f)}h==e.length-1&&g&&(l=f-k%f,l<f&&P(a,c,l))}d.types=a;d.size=0;for(c=0;c<d.types.length;c++)d.types[c].m.u?(d.size+=d.types[c].G,d.types[c].size+=d.types[c].G):0==d.types[c].m.bits&&
b?(d.size+=d.types[c].G,d.types[c].size+=d.types[c].G):(d.size+=d.types[c].m.offset*d.types[c].G,d.types[c].size=d.types[c].m.offset*d.types[c].G)}d.size=Math.ceil(d.size);return d}function R(a){return a.replace(/[<>!=@#~%&\+\-]/g,"")}
function S(a,b){var c=["~","@","#"];for(let d=0;d<c.length;d++)if(-1<a.indexOf(c[d])){let g=a.split(c[d]);a=g[1];b.X=c[d];c=""==g[0]?0:parseInt(g[0],10);b.bits=0==c?8:c;if(b.bits%8||isNaN(b.bits)||0>b.bits)throw Error("Architecture bit width must be a multiple of the bit width (8)");break}c=a.slice(-1);"%"==c?(a=a.slice(0,-1),b.ca=!1):"&"==c&&(a=a.slice(0,-1),b.ca=!0);return a}function T(a){let b="=";a=a.charAt(0);if("!"==a||"<"==a||">"==a)b=a;return b}
function U(a,b){a=H[a];a.W=b.charAt(0);a.offset=Math.ceil((0<a.bits?a.bits:1)/8);if(8<a.offset){b=a.offset;let c=b%8;b=0===c?b:b+(8-c)}else b=4<a.offset?8:2<a.offset?4:a.offset;a.align=b;4==a.bits&&a.b&&(a.offset=.5,a.align=1);return a}
function V(a,b,c,d=0,g=!1){b=W(b);a=Q(a);if(a.$>b.length)throw Error("Number of values do not match the format");for(let e=0,f=0,h=a.types.length;e<h;e++){let k=a.types[e];k.Z=0;if(0===k.m.bits)for(let l=0;l<k.G;l++)c[d]=0,d++;else k.m.v?(d=M(k,b[f],c,d,!0,f),f++):(d=J(k,b.slice(f,f+k.G),c,d,g,e),f+=k.G)}return d}
function X(a,b,c,d=0,g=!1){a=Q(a);let e=a.types.length;for(let f=0,h=0;f<e;f++){let k=a.types[f].G,l=a.types[f];l.Z=0;let m=l.m.bits&&!l.m.u?l.m.offset*k:k;m=Math.ceil(m);let n=d+m;l.m.v?h=O(l,b,c,d,n,h):0!==l.m.bits&&(h=N(l,b,c,d,n,h,k,g));d+=m}}function Y(a,b,c,d=0,g=!1){b=W(b);a=Q(a,!0,!0,b).types[0];if(4==a.m.bits&&a.m.b&&b.length%2)throw Error("Odd number of nibbles");return a.m.v?M(a,b[0],c,d,!1,0):J(a,b,c,d,g,0)}
function Z(a,b,c,d=0,g=b.length,e=!1){a=Q(a,!0,!0).types[0];return a.m.v?O(a,b,c,d,g,0):N(a,b,c,d,g,0,2*(g-d+1),e)}function W(a){null!==a&&void 0!==a&&"string"!==typeof a&&"function"!==typeof a&&"number"===typeof a.length&&0<=a.length&&a.length===Math.floor(a.length)||(a=[a]);return a}function bytesToHex(a){let b="";for(let c=0;c<a.length;c++){if(0>a[c]||255<a[c])throw new RangeError;let d=a[c].toString(16);b+=1==d.length?"0"+d:d}return b};function calcSize(a,b=!1){return Q(a,b).size};
function calcSizeByValues(a,b){a=Q(a,!0,!0,b);return a.types[0]&&b.length?Math.ceil(a.types[0].size):0};function hexToBytes(a){if(0!==a.length%2&&0<a.length)throw Error("Invalid hex string");if(!/^[0-9a-fA-F]+$/.test(a)&&0<a.length)throw new RangeError("Invalid hex string");let b=[];for(let c=0;c<a.length;c+=2)b.push(parseInt(a.substr(c,2),16));return b};function pack(a,b,c=!1){let d=[];V(a,b,d,0,c);return d};
function read(a,b,c=0,d=b.length,g=!1){let e=[];Z(a,b,e,c,d,g);return e};function unpack(a,b,c=0,d=!1){let g=[];X(a,b,g,c,d);return g};function write(a,b,c=!1){let d=[];Y(a,b,d,0,c);return d};export{bytesToHex,calcSize,calcSizeByValues,p as endianness,hexToBytes,pack,V as packTo,read,Z as readTo,H as types,unpack,X as unpackTo,z as utf16BufferSize,E as utf32BufferSize,u as utf8BufferSize,write,Y as writeTo}
